var rodeo = rodeo || {};


rodeo.setupProductSearch = (function (el) {
    var format_css, container, api_url, view_on, div_id, url, productDetail_api_url;
    var parent_element = el;
    // get specifics from the respond system to send off to the api

    container = el.querySelector('#template_huntItemShellhuntProductSearch');
    api_url = el.getAttribute('api_url');
    view_on = el.getAttribute('view_on');
    div_id = el.getAttribute('div_id');
    url = el.getAttribute('url');
    format_css = el.getAttribute('format_css');

    if (format_css === null) {
    } else {
        var link = $("<link />", {
            rel: "stylesheet",
            type: "text/css",
            href: format_css
        })
        $('#products-search-plugin').append(link);
    }

    if (view_on === "default_div" && !div_id) {
        div_id = "hunt_products_search";
    }

    if (view_on === "custom_div" && !div_id) {
        alert("Please enter Custom DIV in the plugin settings first");
        return false;
    }

    if (view_on === "url" && !url) {
        alert("Please enter URL in the plugins settings first");
        return false;
    }

    productDetail_api_url = api_url;
    jQuery.get(productDetail_api_url, {
        div_id: div_id,
        view_on: view_on,
        url: url
    }, function (response) {
        rodeo.rodeoProductSearch(productDetail_api_url, div_id, parent_element, view_on, url);
    });
});

rodeo.rodeoProductSearch = (function (productURL, div_id, el, view_on, url) {
    jQuery.get(productURL, {
        div_id: div_id,
        view_on: view_on,
        url: url
    }, function (response) {
        $(el).find('#hunt_product_detail').html("");
        $(el).find('#hunt_product_detail').append(response.html);
        $('#hunt_products_search').addClass('hide');
        $(el).find('#hunt_product_detail').removeClass('hide');
        rodeo.searchFunction($(el).find('#hunt_product_detail'), response.site_url, div_id, view_on, url);
    });
});

rodeo.searchFunction = (function (target, api_url, div_id, view_on, url) {
    $(target).find('.search-data').on('submit', function () {
        var product_filter = $(this).find('.search-field').val();
        if (view_on === "url") {
            url = (url + '?query=' + product_filter);
            window.location = url;
            return false;
        }
        respond.productSearch.onSearchClick(product_filter, api_url, div_id);
        return false;
    });
});
